/* CUnitTester http://www.gethos.net/opensource/cunit
 * filter.c -- used to filter which suites are loaded
 *
 * Copyright 2003 by Stewart Gebbie
 * For license terms, see the file COPYING in the top directory.
 */
/* $Id: filter.c,v 1.1 2004/12/23 10:45:44 stewart Exp $ */
#include "config.h"
#include "unittester.h"

#include <stdio.h>
#include <stdlib.h>
#include <regex.h>

#include "load.h"
#include "show.h"

#define MAX_REGEX_ERROR_LEN 100
bool FilterSuite (utest_world* world, utest_suite* suite)
{
	int ret = 0;
	regex_t compiledFilter;

	if (world->filter)
	{
		size_t nmatch = 1;
		regmatch_t pmatch[1];
		ret = regcomp (&compiledFilter, world->filter, REG_NOSUB);
		if (ret)
		{
			char errorBuf[MAX_REGEX_ERROR_LEN];
			size_t errorLen = 0;
			errorLen = regerror (ret, &compiledFilter, errorBuf, sizeof(errorBuf));
			uassert (errorLen < sizeof(errorBuf));
			ShowError ("Failed to compile filter regex [%s]: %s\n",
					world->filter, errorBuf);
			exit(1);
		}

		uassert (suite->name);
		ret = regexec (&compiledFilter, suite->name, nmatch, pmatch, 0);

		regfree (&compiledFilter);
	}

	return ret == 0 ? true : false;
}
