/* CUnitTester http://www.gethos.net/opensource/cunit
 * load.c -- loads test suites from shared objects
 *
 * Copyright 2003 by Stewart Gebbie
 * For license terms, see the file COPYING in the top directory.
 */
/* $Id: load.c,v 1.7 2004/12/23 10:45:44 stewart Exp $ */
#include "config.h"
#include "unittester.h"

#include <stdio.h>
#include <stdlib.h>
#include <dlfcn.h>

#include "load.h"
#include "show.h"

utest_suite* LoadSuite (const char* tpath, utest_suitelib* sl)
{
	/* load the library */
	utest_suite* (*reghandle)(void) = NULL;
	utest_suite* suite = NULL;
	char* derr = NULL;
	void* handle = dlopen(tpath,RTLD_LAZY);
	derr=dlerror();
	if(derr)
	{
		ShowError ("dlopen() failed: %s\n", derr);
	}
	uassert(handle);

	/* retrieve the registration function */
	reghandle=NULL;
	reghandle=(utest_suite* (*)(void))dlsym(handle, "register_suite");
	derr=dlerror();
	if(derr)
	{
		ShowError ("dlsym() failed: %s\n", derr);
		dlclose(handle);
		abort();
	}

	/* run the registration function to obtain an test suite instance */
	suite=(*reghandle)();
	uassert(suite!=NULL);

	sl->suite = suite;
	sl->handle = handle;

	return suite;
}


void UnloadSuite (utest_suitelib* sl)
{
	uassert (sl->handle);
	dlclose (sl->handle);
}
