/* 
 * world.h -- include needed by all test suites
 *
 * Copyright 2003 by Stewart Gebbie
 * For license terms, see the file COPYING in the top directory.
 */
/* $Id: world.h,v 1.6 2005/01/05 21:16:41 stewart Exp $ */
#ifndef CUNIT_WORLD_H
#define CUNIT_WORLD_H

#include <libcunit/config.h>
#include <libcunit/unittester.h>

typedef struct utest_suite_stub_tag
{
	char libpath[MAXUTESTPATHLEN];
	int testCount;
	utest_suite* suite;
	struct utest_suite_stub_tag* next;
} utest_suite_stub;

typedef struct utest_world_tag
{
	/* config */
	const char* rootDir;
	const char* filter;
	const char* output;
	void* compiledFilter;
	
	/* test counters */
	int suiteCount;
	int testCount;

	int finSuiteCount;
	int finTestCount;

	int badTestCount;
	int goodTestCount;

	/* times */
	long secStart;
	long usecStart;
	long secEnd;
	long usecEnd;

	/* tests */
	void (*addstub)(struct utest_world_tag*, utest_suite_stub*);
	utest_suite_stub* stubHead;
	utest_suite_stub* stubTail;

	void (*addinfo)(struct utest_world_tag*, utest_info*);
	utest_info* infoHead;
	utest_info* infoTail;
} utest_world;

void InitWorld (utest_world* world);
void FiniWorld (utest_world* world);
void InitWorldTimers (utest_world* world);
void FiniWorldTimers (utest_world* world);

void AppendStub (utest_world* world, utest_suite_stub* stub);
void AppendInfo (utest_world* world, utest_info* info);

#endif /* CUNIT_WORLD_H */
